=== man/CMakeLists.txt ===
install(FILES
  man1/proj.1
  man1/cs2cs.1
  man1/geod.1
  man1/cct.1
  man1/gie.1
  man1/projinfo.1
  man1/projsync.1
  DESTINATION share/man/man1)
