=== debian/changelog ===
proj (8.2.1-1) unstable; urgency=medium

  * New upstream release.
  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 01 Jan 2022 16:20:08 +0100

proj (8.2.1~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 26 Dec 2021 16:46:46 +0100

proj (8.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Update 8.2.0~rc1 symbols other architectures.
  * Strip pre-releases from symbols version.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 01 Nov 2021 18:59:51 +0100

proj (8.2.0~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update copyright file.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 27 Oct 2021 05:57:13 +0200

proj (8.1.1-1) unstable; urgency=medium

  * Bump Standards-Version to 4.6.0, no changes.
  * Bump debhelper compat to 12, changes:
    - Drop --list-missing from dh_install
  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 22 Oct 2021 06:32:30 +0200

proj (8.1.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update symbols for other architectures.
  * Strip pre-releases from symbols version.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 01 Sep 2021 20:45:39 +0200

proj (8.1.1~rc2-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update symbols for other architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 29 Aug 2021 16:48:32 +0200

proj (8.1.1~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 26 Aug 2021 06:02:51 +0200

proj (8.1.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update 8.1.0~rc1 symbols other architectures.
  * Strip pre-releases from symbols version.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 01 Jul 2021 06:02:51 +0200

proj (8.1.0~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update copyright file.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 25 Jun 2021 18:51:17 +0200

proj (8.0.1-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update symbols for other architectures.
  * Strip pre-releases from symbols version.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 05 May 2021 12:45:31 +0200

proj (8.0.1~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update 8.0.0 symbols for other architectures.
  * Update copyright file.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 28 Apr 2021 13:43:35 +0200

proj (8.0.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update 8.0.0~rc2 symbols for other architectures.
  * Strip pre-releases from symbols version.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 01 Mar 2021 12:49:39 +0100

proj (8.0.0~rc2-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update 8.0.0~rc1 symbols for other architectures.
  * Drop spelling-errors.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 25 Feb 2021 19:58:46 +0100

proj (8.0.0~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update copyright file.
  * Rename library package for SONAME bump.
  * Explicitly remove files in dh_auto_install override.
  * Update symbols for amd64.
  * Add patch to fix spelling errors.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 20 Feb 2021 14:42:38 +0100
