## proj 9.0.1

=== debian/changelog ===
proj (9.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Update symbols for other architectures.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 15 Jun 2022 16:20:21 +0200

proj (9.0.1~rc2-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update symbols for other architectures.
  * Drop soversion.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 08 Jun 2022 20:23:37 +0200

proj (9.0.1~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Drop SQLite 3.38.0 patch, included upstream.
  * Add patch to revert SOVERSION bump.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 08 Jun 2022 18:19:10 +0200

proj (9.0.0-1) unstable; urgency=medium

  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 22 Mar 2022 05:21:32 +0100

proj (9.0.0-1~exp2) experimental; urgency=medium

  * Add upstream patch to fix test failure with SQLite 3.38.0.
  * Update symbols for hppa.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 06 Mar 2022 12:02:05 +0100

proj (9.0.0-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update symbols for other architectures.
  * Ignore test failures, see: https://github.com/OSGeo/PROJ/issues/3077.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 02 Mar 2022 06:45:13 +0100

proj (9.0.0~rc2-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update symbols for other architectures.
  * Update copyright file.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 23 Feb 2022 20:10:25 +0100

proj (9.0.0~rc1-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Switch to cmake buildsystem.
  * Rename library package for SONAME bump.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 15 Feb 2022 22:01:30 +0100
