=== debian/control ===
--- 
+++ 
@@ -4,11 +4,12 @@
            Bas Couwenberg <sebastic@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: cmake,
+               debhelper-compat (= 12),
                libcurl4-gnutls-dev | libcurl-ssl-dev,
+               libgtest-dev,
                libsqlite3-dev,
                libtiff-dev,
-               pkg-config,
                pkg-kde-tools,
                sharutils,
                sqlite3,
@@ -38,7 +39,7 @@
  This package contains auxiliary projection datum grids used by the
  library and tools.
 
-Package: libproj22
+Package: libproj25
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -65,7 +66,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: libproj22 (= ${binary:Version}),
+Depends: libproj25 (= ${binary:Version}),
          libcurl4-gnutls-dev | libcurl-ssl-dev,
          libsqlite3-dev,
          libtiff-dev,
